#include "bonus.h"

extern double fps_factor;

void bonus_firepower_add(SPRITE *s)
{
	SPRITE *bs;
	BONUS_DATA *data;

	bs=sprite_add_file("data/bonus_p.bmp",16,1);
	bs->anim_speed=3;
	bs->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
	if(s->x<600) bs->x=s->x+20; else bs->x=s->x-10;
	bs->y=s->y;
	bs->type=SP_BONUS_FIREPOWER;
	bs->mover=bonus_firepower_move;

	if((data=malloc(sizeof(BONUS_DATA)))==NULL) {
		CHECKPOINT;
		error(ERR_FATAL,"bonus: out of memory");
	}
	bs->data=data;
	
	data->speed=rand()%400/100+1;
}

void bonus_firepower_move(SPRITE *s)
{
	BONUS_DATA *d=(BONUS_DATA *)s->data;

	s->y+=d->speed*fps_factor;
	if(s->y>480) s->type=-1;
}

void bonus_speed_add(SPRITE *s)
{
	SPRITE *bs;
	BONUS_DATA *data;

	bs=sprite_add_file("data/bonus_s.bmp",16,1);
	bs->anim_speed=3;
	bs->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
	if(s->x<600) bs->x=s->x+20; else bs->x=s->x-10;
	bs->y=s->y;
	bs->type=SP_BONUS_ADDSPEED;
	bs->mover=bonus_speed_move;

	if((data=malloc(sizeof(BONUS_DATA)))==NULL) {
		CHECKPOINT;
		error(ERR_FATAL,"bonus: out of memory");
	}
	bs->data=data;
	
	data->speed=rand()%400/100+1;
}

void bonus_speed_move(SPRITE *s)
{
	BONUS_DATA *d=(BONUS_DATA *)s->data;

	s->y+=d->speed*fps_factor;
	if(s->y>480) s->type=-1;
}

void bonus_bomb_add(SPRITE *s)
{
	SPRITE *bs;
	BONUS_DATA *data;

	bs=sprite_add_file("data/bonus_f.bmp",16,1);
	bs->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
	bs->anim_speed=3;
	if(s->x<600) bs->x=s->x+20; else bs->x=s->x-10;
	bs->y=s->y;
	bs->type=SP_BONUS_BOMB;
	bs->mover=bonus_bomb_move;

	if((data=malloc(sizeof(BONUS_DATA)))==NULL) {
		CHECKPOINT;
		error(ERR_FATAL,"bonus: out of memory");
	}
	bs->data=data;
	
	data->speed=rand()%400/100+1;
}

void bonus_bomb_move(SPRITE *s)
{
	BONUS_DATA *d=(BONUS_DATA *)s->data;

	s->y+=d->speed*fps_factor;
	if(s->y>480) s->type=-1;
}

void bonus_coin_add(SPRITE *s)
{
	SPRITE *bs;
	BONUS_DATA *data;

	bs=sprite_add_file("data/coin.bmp",20,1);
	bs->anim_speed=3;
	bs->aktframe=rand()%3;
	bs->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
	if(s->x<600) bs->x=s->x+20; else bs->x=s->x-10;
	bs->y=s->y;
	bs->type=SP_BONUS_COIN;
	bs->mover=bonus_coin_move;

	if((data=malloc(sizeof(BONUS_DATA)))==NULL) {
		CHECKPOINT;
		error(ERR_FATAL,"bonus: out of memory");
	}
	bs->data=data;
	
	data->speed=rand()%400/100+1;
}

void bonus_coin_move(SPRITE *s)
{
	BONUS_DATA *d=(BONUS_DATA *)s->data;

	s->y+=d->speed*fps_factor;
	if(s->y>480) s->type=-1;
}

void bonus_info_add(int x, int y, char *filename)
{
	SPRITE *c;
	c=sprite_add_file(filename,1,1);
	c->flags=SP_FLAG_VISIBLE;
	c->type=SP_ETC;
	c->x=x;
	c->y=y;
	c->alpha=255;
	c->mover=bonus_info_move;
}

void bonus_info_move(SPRITE *c)
{
	if(c->alpha>=3*fps_factor) {
		c->alpha-=3*fps_factor;
		c->y-=fps_factor;
	} else {
		c->type=-1;
	}
}
