#include "clouds.h"

SPRITE *w1[5];
SPRITE *w2[10];
SPRITE *w3[20];

extern double fps_factor;

void clouds_init()
{
	int i;
	CLOUDS_DATA *d;

	for(i=0;i<20;i++) {
		w3[i]=sprite_add_file("data/wolke03.bmp",1,1);
		w3[i]->x=((rand()%640)+w3[i]->w)-(2*w3[i]->w);
		w3[i]->y=rand()%480;
		w3[i]->flags&=~SP_FLAG_COLCHECK;
		w3[i]->flags|=SP_FLAG_VISIBLE;
		w3[i]->type=SP_CLOUDS;
		w3[i]->mover=clouds_mover;
		if((d=malloc(sizeof(CLOUDS_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"clouds: out of memory");
		}
		w3[i]->data=d;
		d->speed_base=3;
		d->speed_rand=(rand()%100)/100;
	}

	for(i=0;i<10;i++) {
		w2[i]=sprite_add_file("data/wolke02.bmp",1,1);
		w2[i]->x=((rand()%640)+w2[i]->w)-(2*w2[i]->w);
		w2[i]->y=rand()%480;
		w2[i]->flags&=~SP_FLAG_COLCHECK;
		w2[i]->flags|=SP_FLAG_VISIBLE;
		w2[i]->type=SP_CLOUDS;
		w2[i]->mover=clouds_mover;
		if((d=malloc(sizeof(CLOUDS_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"clouds: out of memory");
		}
		w2[i]->data=d;
		d->speed_base=2;
		d->speed_rand=(rand()%100)/100;
	}

	for(i=0;i<5;i++) {
		w1[i]=sprite_add_file("data/wolke01.bmp",1,1);
		w1[i]->x=((rand()%640)+w1[i]->w)-(2*w1[i]->w);
		w1[i]->y=rand()%480;
		w1[i]->flags&=~SP_FLAG_COLCHECK;
		w1[i]->flags|=SP_FLAG_VISIBLE;
		w1[i]->type=SP_CLOUDS;
		w1[i]->mover=clouds_mover;
		if((d=malloc(sizeof(CLOUDS_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"clouds: out of memory");
		}
		w1[i]->data=d;
		d->speed_base=1;
		d->speed_rand=(rand()%100)/100;
	}
	
}

void clouds_remove()
{
	int i;

	for(i=0;i<20;i++) {
		if(i<5) w1[i]->type=-1;
		if(i<10) w2[i]->type=-1;
		w3[i]->type=-1;
	}
}

void clouds_mover(SPRITE *c)
{
	CLOUDS_DATA *d=(CLOUDS_DATA *)c->data;

	c->y+=d->speed_base*fps_factor;
	c->y+=d->speed_rand*fps_factor;
	if(c->y>480) {
		c->y-=480+c->w;
		d->speed_rand=(rand()%100)/100;
		c->x=((rand()%640)+c->w)-(2*c->w);
	}
}
