#ifndef _ENEMY_H_
#define _ENEMY_H_
#include <SDL/SDL.h>
#include <stdlib.h>
#include <math.h>

#include "sprite.h"
#include "particle.h"
#include "support.h"
#include "bonus.h"

struct _enemy_base {
	int score;
	int health;
};
typedef struct _enemy_base ENEMY_BASE;

struct _crusher_data {
	ENEMY_BASE b;
	int c1;
	int c2;
};
typedef struct _crusher_data CRUSHER_DATA;

struct _cube_data {
	ENEMY_BASE b;
	int radius;
	int winkel;
	int flag0;
	int flag1;
	int flag2;
};
typedef struct _cube_data CUBE_DATA;

struct _drager_data {
	ENEMY_BASE b;
	int anim_dir;
	int anim_speed;
	int anim_count;
};
typedef struct _drager_data DRAGER_DATA;

struct _eyefo_data {
	ENEMY_BASE b;
	double radius;
	int flag1;
	double winkel;
	int counter;
	int xcenter;
	int ycenter;
	
};
typedef struct _eyefo_data EYEFO_DATA;

struct _xev_data {
	ENEMY_BASE b;
	int state;
	int tx;
	int ty;
	
};
typedef struct _xev_data XEV_DATA;

struct _mine_data {
	ENEMY_BASE b;
	int state;
	int tx;
	int ty;
	int delay;
	
};
typedef struct _mine_data MINE_DATA;

struct _bullet_data {
	double angle;
	double speed;
};
typedef struct _bullet_data BULLET_DATA;

struct _homing_data {
	ENEMY_BASE b;
	int angle;
	int speed;
	int range;
	int delay;
};
typedef struct _homing_data HOMING_DATA;

struct _rwingx_data {
	ENEMY_BASE b;
	int winkel;
	double speed;
	int state;
	int wait;
};
typedef struct _rwingx_data RWINGX_DATA;

struct _cir_data {
	ENEMY_BASE b;
	double winkel;
	double speed;
	int state;
};
typedef struct _cir_data CIR_DATA;

struct _zatak_data {
	ENEMY_BASE b;
	double winkel;
	double speed;
	int state;
	double wait;
};
typedef struct _zatak_data ZATAK_DATA;
	

void enemy_add_wave(int type);
void enemy_bullet_create(SPRITE *s, int speed);
void enemy_bullet_move(SPRITE *s);
void enemy_homing_create(SPRITE *s);
void enemy_homing_update(SPRITE *s);
void enemy_homing_move(SPRITE *s);

void enemy_crusher_add();
void enemy_crusher_move(SPRITE *s);

void enemy_cube_add();
void enemy_cube_move(SPRITE *s);

void enemy_drager_add();
void enemy_drager_move(SPRITE *s);

void enemy_eyefo_add();
void enemy_eyefo_move(SPRITE *s);

void enemy_xev_add();
void enemy_xev_move(SPRITE *s);

void enemy_mine_add();
void enemy_mine_move(SPRITE *s);
void enemy_supermine_add(SPRITE *s);
void enemy_supermine_move(SPRITE *s);

void enemy_rwingx_add();
void enemy_rwingx_move(SPRITE *s);

void enemy_cir_add();
void enemy_cir_move(SPRITE *s);

void enemy_zatak_add();
void enemy_zatak_move(SPRITE *s);

void enemy_boss01_add();
void enemy_boss01_setpos(int x, int y);
void enemy_boss01_hitbyplayer(SPRITE *c);
void enemy_boss01_hitbyweapon(SPRITE *c, int angle);
void explosion_add(int x, int y);
void explosion_move(SPRITE *c);
void enemy_boss01_move(SPRITE *c);
void enemy_boss01_fire(int where);

#endif

