#include "enemy.h"

SPRITE *sb01[6];
extern int score;
extern double fps_factor;
extern SDL_Surface *screen;

struct _boss01_data {
	ENEMY_BASE b;
	int state;
};
typedef struct _boss01_data BOSS01_DATA;

void enemy_boss01_add()
{
	int i;
	BOSS01_DATA *b;

	error(ERR_DEBUG,"attention, boss...");

	sb01[0]=sprite_add_file("data/boss01-lo.bmp",2,1);
	sb01[1]=sprite_add_file("data/boss01-mo.bmp",2,1);
	sb01[2]=sprite_add_file("data/boss01-ro.bmp",2,1);
	sb01[3]=sprite_add_file("data/boss01-lu.bmp",2,1);
	sb01[4]=sprite_add_file("data/boss01-mu.bmp",2,1);
	sb01[5]=sprite_add_file("data/boss01-ru.bmp",2,1);

	for(i=0;i<6;i++) {
		sb01[i]->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
		sb01[i]->anim_speed=0;
		sb01[i]->aktframe=0;
		sb01[i]->type=SP_EN_BOSS01;
		if((b=malloc(sizeof(BOSS01_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"out of memory");
		}
		sb01[i]->data=b;
		b->b.health=20;
		b->b.score=500;
		if(i==1) {
			b->state=0;
			sb01[i]->mover=enemy_boss01_move;
		}

	}
}

void enemy_boss01_setpos(int x, int y)
{
	sb01[0]->x=x;
	sb01[0]->y=y;
	sb01[1]->x=sb01[0]->w+sb01[0]->x;
	sb01[1]->y=y;
	sb01[2]->x=sb01[1]->w+sb01[1]->x;
	sb01[2]->y=y;
	sb01[3]->x=x;
	sb01[3]->y=sb01[0]->h+y;
	sb01[4]->x=sb01[3]->w+sb01[3]->x;
	sb01[4]->y=sb01[1]->h+y;
	sb01[5]->x=sb01[4]->w+sb01[4]->x;
	sb01[5]->y=sb01[2]->h+y;
}

/* boss wurde von player berhrt */
void enemy_boss01_hitbyplayer(SPRITE *c)
{
}

/* boss wurde von player-weapon berhrt */
void enemy_boss01_hitbyweapon(SPRITE *c, int angle)
{
	int i,j;
	BOSS01_DATA *b;
	SDL_Surface *spimg;

	for(i=0;i<6;i++)
		if(c==sb01[i])
			break;

	switch(i) {
		case 0:
			if(sb01[3]->flags&SP_FLAG_VISIBLE)
				i=3;
			break;

		case 1:
			if(sb01[4]->flags&SP_FLAG_VISIBLE)
				i=4;
			else if(sb01[3]->flags&SP_FLAG_VISIBLE)
				i=3;
			else if(sb01[5]->flags&SP_FLAG_VISIBLE)
				i=5;
			else if(sb01[0]->flags&SP_FLAG_VISIBLE)
				i=0;
			else if(sb01[2]->flags&SP_FLAG_VISIBLE)
				i=2;
			break;

		case 2:
			if(sb01[5]->flags&SP_FLAG_VISIBLE)
				i=5;
			break;
	}
	
	b=(BOSS01_DATA *)sb01[i]->data;
	b->b.health--;

	spimg=sprite_getcurrimg(sb01[i]);
	parsys_add(spimg, 2,2, c->x,c->y, 10, angle, 10, 30, EXPLODE|DIFFSIZE, NULL);
	SDL_FreeSurface(spimg);

	switch(b->b.health) {
		case 10:
			sb01[i]->aktframe=1;
			explosion_add(sb01[i]->x+sb01[i]->w/2,sb01[i]->y+sb01[i]->h/2);
			break;
		case 0:
			explosion_add(sb01[i]->x+sb01[i]->w/2,sb01[i]->y+sb01[i]->h/2);
			sb01[i]->flags&=~SP_FLAG_VISIBLE;
			sb01[i]->flags&=~SP_FLAG_COLCHECK;
			score+=b->b.score;
			break;
	}

	j=0;
	for(i=0;i<6;i++) {
		if(sb01[i]->flags&SP_FLAG_VISIBLE)
			j++;
	}
	if(j==0) {
		/* boss komplett zerstrt */
		for(i=0;i<6;i++) {
			sb01[i]->type=-1;
			explosion_add(sb01[i]->x+sb01[i]->w/2,sb01[i]->y+sb01[i]->h/2);
		}
	}
		

}

void explosion_add(int x, int y)
{
	SPRITE *ex;

	ex=sprite_add_file("data/ex.bmp",29,1);
	ex->flags|=(SP_FLAG_VISIBLE);
	ex->anim_speed=0;
	ex->aktframe=0;
	ex->type=SP_ETC;
	ex->x=x-(ex->w/2);
	ex->y=y-(ex->h/2);
	ex->mover=explosion_move;
}

void explosion_move(SPRITE *c)
{
	if(c->aktframe<c->frames-1) {
		c->aktframe++;
	} else {
		c->type=-1;
	}
}

void enemy_boss01_move(SPRITE *c)
{
	BOSS01_DATA *b=(BOSS01_DATA *)c->data;
	static double x,y;
	static double w;
	static double firewait1,firewait2;

	switch(b->state) {
		case 0:
			x=screen->w/2-(sb01[0]->w+sb01[1]->w+sb01[2]->w)/2;
			y=-100;
			enemy_boss01_setpos(x,y);
			b->state=1;
			firewait1=45;
			firewait2=200;
			break;
		case 1:
			y+=fps_factor;
			enemy_boss01_setpos(x,y);
			if(y>=30) {
				b->state=2;
				w=0;
			}
			break;
		case 2:
			w+=fps_factor;
			if(w>=40) {
				b->state=3;
			}
			break;
		case 3:
			y+=fps_factor;
			enemy_boss01_setpos(x,y);
			if(y>=80) {
				b->state=4;
				w=0;
			}
			break;
		case 4:
			w+=fps_factor;
			if(w>=30) {
				b->state=5;
				w=0;
			}
			break;
		case 5:
			y+=fps_factor;
			x-=2*fps_factor;
			w+=fps_factor;
			enemy_boss01_setpos(x,y);
			if(w>=60)
				b->state=6;
			break;
		case 6:
			y-=fps_factor;
			x+=2*fps_factor;
			w-=fps_factor;
			enemy_boss01_setpos(x,y);
			if(w<=0)
				b->state=7;
			break;
		case 7:
			y+=fps_factor;
			x+=2*fps_factor;
			w+=fps_factor;
			enemy_boss01_setpos(x,y);
			if(w>=60)
				b->state=8;
			break;
		case 8:
			y-=fps_factor;
			x-=2*fps_factor;
			w-=fps_factor;
			enemy_boss01_setpos(x,y);
			if(w<=0)
				b->state=4;
			break;
	}

	firewait1-=fps_factor;
	firewait2-=fps_factor;
	if(firewait1<=0) {
		firewait1=45;
		enemy_boss01_fire(0);
		enemy_boss01_fire(1);
	}
	if(firewait2<=0) {
		firewait2=200;
		enemy_boss01_fire(2);
	}
}

void enemy_boss01_fire(int where) /* 0: left, 1: right, 2: bombenhagel */
{
	SPRITE *b;
	BULLET_DATA *data;
	int angle;

	switch(where) {
		case 0:
			if(sb01[3]->flags&SP_FLAG_VISIBLE)
				enemy_bullet_create(sb01[3],5);
			break;
		case 1:
			if(sb01[5]->flags&SP_FLAG_VISIBLE)
				enemy_bullet_create(sb01[5],5);
			break;
		case 2:
			for(angle=270-45;angle<=270+45;angle+=15) {
				b=sprite_add_file("data/kugel.bmp",1,1);
				b->type=SP_EN_BULLET;
				b->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
				b->mover=enemy_bullet_move;
				b->aktframe=0;
				b->x=sb01[4]->x;
				b->y=sb01[4]->y;
				if((data=malloc(sizeof(BULLET_DATA)))==NULL) {
					CHECKPOINT;
					error(ERR_FATAL,"out of memory");
				}
				b->data=data;
				data->angle=((double)angle/180*M_PI)-M_PI;
				data->speed=4*fps_factor;
			}
			break;
	}
}
