#include "enemy.h"

extern double fps_factor;
extern SPRITE *player;

void enemy_cir_add()
{
	int i;
	SPRITE *s;
	CIR_DATA *data;

	for(i=0;i<24;i++) {
		s=sprite_add_file("data/rwingx.bmp",37,1);
		s->type=SP_EN_CIR;
		s->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
		s->mover=enemy_cir_move;
		s->anim_speed=0;
		s->aktframe=0;
		if((data=malloc(sizeof(CIR_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"out of memory");
		}
		s->data=data;
		data->b.score=25;
		data->b.health=1;
		data->winkel=270;
		data->speed=6*fps_factor;
		data->state=0;
		s->x=i%2==0?30:50;
		s->y=-(i*20);
	}
}


void enemy_cir_move(SPRITE *s)
{
	CIR_DATA *d=(CIR_DATA *)s->data;
	double dummy;

	switch(d->state) {
		case 0:	/* down */
			if(s->y>200) {
				d->state=1;
				d->speed=3*fps_factor;
			}
			break;
		case 1: /* turn */
			d->winkel-=0.5;
			if(d->winkel==90) {
				d->state=2;
				d->speed=8*fps_factor;
			}
			break;
		case 2: /* up */
			if(s->y<50) {
				d->state=3;
				d->speed=3*fps_factor;
			}
			break;
		case 3: /* turn */
			d->winkel-=0.5;
			if(d->winkel<0)
				d->winkel+=360;
			if(d->winkel==270) {
				d->state=4;
				d->speed=6*fps_factor;
			}
			break;
		case 4: /* down */
			if(s->y>480)
				s->type=-1;
			break;
	}
	dummy=((double)d->winkel/180*M_PI)-M_PI;
	s->x+=cos(dummy)*d->speed;
	s->y+=sin(dummy)*d->speed;
	s->aktframe=(((int)d->winkel+90)%360)/10;
}
