#include "enemy.h"

extern double fps_factor;

void enemy_cube_add()
{
	int i;
	SPRITE *s;
	CUBE_DATA *data;

	for(i=0;i<16;i++) {
		s=sprite_add_file("data/cube.bmp",16,1);
		s->type=SP_EN_CUBE;
		s->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
		s->mover=enemy_cube_move;
		s->anim_speed=1;
		s->aktframe=i%s->frames;
		if((data=malloc(sizeof(CUBE_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"out of memory");
		}
		s->data=data;
		data->b.score=15;
		data->b.health=1;
		data->radius=350;
		data->winkel=360/16*i;
		data->flag0=1;
		data->flag1=0;
		data->flag2=0;
	}
}

void enemy_cube_move(SPRITE *s)
{
	double dummy;
	CUBE_DATA *d=(CUBE_DATA *)s->data;
	
	d->flag2+=fps_factor;
	if(d->flag2<500) {
		if(!d->flag1) {
			d->radius+=fps_factor;
			if(d->radius>150) d->flag1=1;
		} else {
			d->radius-=fps_factor;
			if(d->radius<=10) d->flag1=0;
		}
		d->winkel-=3*fps_factor;
		d->winkel%=360;

		if(!(rand()%500)) {
			enemy_bullet_create(s,1);
		}

		if(!(rand()%600)) {
			bonus_firepower_add(s);
		}
	} else {
		d->radius+=2*fps_factor;
		if(d->radius>350)
			s->type=-1;
	}

	dummy=((double)d->winkel/180*M_PI)-M_PI;
	s->x=(cos(dummy)*d->radius)+320;
	s->y=(sin(dummy)*d->radius)+170;

}
