#include "enemy.h"

extern double fps_factor;

void enemy_eyefo_add()
{
	int i;
	SPRITE *s;
	EYEFO_DATA *data;

	for(i=0;i<16;i++) {
		s=sprite_add_file("data/eyefo.bmp",15,1);
		s->type=SP_EN_EYEFO;
		s->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
		s->mover=enemy_eyefo_move;
		s->anim_speed=2;
		s->aktframe=i%s->frames;
		if((data=malloc(sizeof(EYEFO_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"out of memory");
		}
		s->data=data;
		data->b.score=10;
		data->b.health=1;
		data->radius=10;
		data->flag1=0;
		data->winkel=360/16*i;
		data->counter=0;
		data->xcenter=320;
		data->ycenter=-100;

	}
}

void enemy_eyefo_move(SPRITE *s)
{
	double dummy;
	EYEFO_DATA *d=(EYEFO_DATA *)s->data;
	
	if(!d->flag1) {
		d->radius+=fps_factor;
		if(d->radius>150) d->flag1=1;
	} else {
		d->radius-=fps_factor;
		if(d->radius<=10) d->flag1=0;
	}
	d->winkel+=5*fps_factor;
	if(d->winkel>=360)
		d->winkel-=360;
	dummy=((double)d->winkel/180*M_PI)-M_PI;
	s->x=(cos(dummy)*d->radius)+d->xcenter;
	s->y=(sin(dummy)*d->radius)+d->ycenter;

	if(!(rand()%800)) {
		enemy_homing_create(s);
	}
	if(!(rand()%1000)) {
		bonus_bomb_add(s);
	}

	d->counter+=fps_factor;
	if(d->counter<300) {
		if(d->ycenter<320)
			d->ycenter++;
	} else if(d->counter>600) {
			d->ycenter--;
			if(d->ycenter+s->y<-s->w)
				s->type=-1;
	}
}
