#include "enemy.h"

extern double fps_factor;

void enemy_mine_add()
{
	SPRITE *s;
	MINE_DATA *data;

	s=sprite_add_file("data/12side.bmp",19,1);
	s->type=SP_EN_MINE;
	s->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
	s->mover=enemy_mine_move;
	s->anim_speed=2;
	s->aktframe=0;
	s->x=rand()%650-10;
	s->y=-40;
	if((data=malloc(sizeof(MINE_DATA)))==NULL) {
		CHECKPOINT;
		error(ERR_FATAL,"out of memory");
	}
	s->data=data;
	data->b.score=30;
	data->b.health=5;
	data->tx=rand()%500+50;
	data->ty=rand()%300+50;
	data->state=0;
}

void enemy_mine_move(SPRITE *s)
{
	MINE_DATA *d=(MINE_DATA *)s->data;
	double angle;

	switch(d->state) {
		case 0: /* move */
			angle=atan2(d->ty-s->y,d->tx-s->x);
			s->x+=cos(angle)*1.5*fps_factor;
			s->y+=sin(angle)*1.5*fps_factor;
			if((s->x >= d->tx-1) && (s->x <= d->tx+1) &&
			   (s->y >= d->ty-1) && (s->y <= d->ty+1)) {
				d->state=1;
				d->delay=40;
			}
			break;
		case 1:
			d->delay-=fps_factor;
			if(d->delay<=0) {
				d->state=2;
				d->delay=10;
				s->anim_speed=0;
			}
			break;
		case 2:
			d->delay-=fps_factor;
			if(d->delay<=0) {
				enemy_supermine_add(s);
				s->type=-1;
			}
			break;
	}
			
}

void enemy_supermine_add(SPRITE *c)
{
	SPRITE *s;
	MINE_DATA *data;
	int i;

	for(i=0;i<8;i++) {
		s=sprite_add_file("data/12side.bmp",19,1);
		s->type=SP_EN_MINE;
		s->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
		s->mover=enemy_supermine_move;
		s->anim_speed=2;
		s->aktframe=0;
		s->x=c->x;
		s->y=c->y;
		if((data=malloc(sizeof(MINE_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"out of memory");
		}
		s->data=data;
		data->b.score=10;
		data->b.health=1;
		data->state=(360/8)*i;
	}
}

void enemy_supermine_move(SPRITE *s)
{
	MINE_DATA *d=(MINE_DATA *)s->data;
	double angle;

	angle=((double)d->state/180*M_PI)-M_PI;
	s->x+=cos(angle)*3*fps_factor;
	s->y+=sin(angle)*3*fps_factor;

	if((s->x<0-s->w)||(s->x>640)||(s->y<0-s->h)||(s->y>480))
		s->type=-1;
}
