#include "enemy.h"

extern double fps_factor;
extern SPRITE *player;

void enemy_rwingx_add()
{
	int i;
	SPRITE *s;
	RWINGX_DATA *data;

	for(i=0;i<24;i++) {
		s=sprite_add_file("data/rwingx.bmp",37,1);
		s->type=SP_EN_RWINGX;
		s->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
		s->mover=enemy_rwingx_move;
		s->anim_speed=0;
		s->aktframe=0;
		if((data=malloc(sizeof(RWINGX_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"out of memory");
		}
		s->data=data;
		data->b.score=25;
		data->b.health=1;
		data->winkel=270;
		data->speed=0;
		data->state=0;
		data->wait=20*fps_factor;
		s->x=i*25;
		s->y=-50;
	}
}


void enemy_rwingx_move(SPRITE *s)
{
	RWINGX_DATA *d=(RWINGX_DATA *)s->data;
	double dummy;

	switch(d->state) {
		case 0: /* sleep(d->wait) ticks */
			if(d->wait) {
				d->wait--;
			} else {
				/* langsam nach unten */
				d->state=1;
				d->winkel=270;
				d->speed=1*fps_factor;
				d->wait=100*fps_factor;
			}
			break;
		case 1: /* move (d->wait) ticks */
			if(d->wait) {
				d->wait--;
			} else {
				d->state=2;
				d->wait=60*fps_factor;
				d->speed=0;
			}
			break;
		case 2: /* sleep(d->wait) ticks */
			if(d->wait) {
				d->wait--;
			} else {
				/* schnell richtung player */
				d->state=3;
				d->winkel=(double)(((atan2(player->y-s->y,player->x-s->x)+M_PI)*180)/M_PI);
				d->speed=4*fps_factor;
				d->wait=100*fps_factor;
			}
			break;
		case 3: /* move (d->wait) ticks */
			if(d->wait) {
				d->wait--;
			} else {
				/* Bombe oder Bonus werfen und schnell abhauen */
				if(rand()%2==0) {
					bonus_speed_add(s);
				} else {
					enemy_bullet_create(s,3);
				}
				d->state=4;
				d->winkel+=180;
				d->winkel%=360;
				d->speed=4.5*fps_factor;
			}
			break;
		case 4:
			if((s->x<-s->w) || (s->x>640) || (s->y<-s->h) || (s->y>480))
				s->type=-1;
			break;
	}

	dummy=((double)d->winkel/180*M_PI)-M_PI;
	s->x+=cos(dummy)*d->speed;
	s->y+=sin(dummy)*d->speed;
	s->aktframe=((d->winkel+90)%360)/10;
}
