#include "enemy.h"

extern SPRITE *player;

extern double fps_factor;

void enemy_xev_add()
{
	int i;
	SPRITE *s;
	XEV_DATA *data;

	for(i=0;i<3;i++) {
		s=sprite_add_file("data/crusher.bmp",15,1);
		s->type=SP_EN_XEV;
		s->flags|=(SP_FLAG_VISIBLE|SP_FLAG_COLCHECK);
		s->mover=enemy_xev_move;
		s->anim_speed=1;
		s->aktframe=0;
		switch(rand()%3) {
			case 0: s->x=rand()%20; break;
			case 1: s->x=640-rand()%20; break;
			case 2: s->x=310+rand()%20; break;
		}
		s->y=rand()%20-50;
		if((data=malloc(sizeof(XEV_DATA)))==NULL) {
			CHECKPOINT;
			error(ERR_FATAL,"out of memory");
		}
		s->data=data;
		data->b.score=5;
		data->b.health=1;
		data->state=0;
		data->tx=player->x;
		data->ty=player->y;

	}
}

void enemy_xev_move(SPRITE *s)
{
	double angle;
	double speed=0;
	XEV_DATA *d=(XEV_DATA *)s->data;
	
	switch(d->state) {
		case 0:
			speed=3;
			if((s->x >= player->x)||(s->y>400)) {
				d->state=1;
				s->anim_speed=-1;
				d->tx=-100;
				d->ty=player->y;
				enemy_bullet_create(s,2);
				if(rand()%3) bonus_coin_add(s);
			}
			
		case 1:
			speed=6;
			if(s->x <= -s->w) {
				s->type=-1;
			}
	}

	angle=atan2(d->ty-s->y,d->tx-s->x);
	s->x+=cos(angle)*speed*fps_factor;
	s->y+=sin(angle)*speed*fps_factor;
}
