#include "fps.h"

Uint32 fps_gamestart;
Uint32 fps_lasttime;
Uint32 fps_frames;
double fps_factor;
int fps;
int fps_method;
int fps_display;

extern SDL_Surface *screen;


void fps_init()
{
	fps_gamestart=SDL_GetTicks();
	fps_lasttime=fps_gamestart;
	fps_frames=0;
	fps_factor=1;
	fps_method=MAXFPS;
	fps_display=0;
}

void fps_show()
{
	char fpstxt[5];
	SDL_Surface *t;
	SDL_Rect r;

	if(fps_display) {
		if(fps_method==MAXFPS) {
			sprintf(fpstxt,"%03d",fps);
		} else {
			sprintf(fpstxt,"FIX");
		}

		t=font_render(fpstxt,FONT03);
		r.x=screen->w-t->w;
		r.y=screen->h-t->h;
		SDL_BlitSurface(t,NULL,screen,&r);
		SDL_FreeSurface(t);
	}
}

void toggle_fps()
{
	if(fps_method==MAXFPS) {
		fps_method=WAITFORFRAME;
		fps_factor=1;
	} else {
		fps_method=MAXFPS;
		fps_factor=1;
	}
}

void fps_newframe()
{
	static Uint32 nexttime=0;
	Uint32 now;

	fps_frames++;
	now=SDL_GetTicks();

	switch(fps_method) {
		case WAITFORFRAME:
			if(nexttime<=now)
				nexttime=now+TICK_INTERVAL;
			else
				SDL_Delay(nexttime-now);
			break;
			
		case MAXFPS:
			fps_factor=(double)(now-fps_lasttime)*PIXEL_SPEED/1000;
			fps=1/((double)(now-fps_lasttime)/1000);
			fps_lasttime=now;
			break;
			
	}
}
