#ifndef _PLAYER_H_
#define _PLAYER_H_
#include <SDL/SDL.h>
#include <math.h>

#include "support.h"
#include "sprite.h"
#include "particle.h"
#include "enemy.h"

enum _player_state { PL_NORMAL, PL_EXPLODE, PL_SAVE };

struct _player_data {
	int state;
	int firewait;
	int explode;
	int save_delay;
	int anim_delay;
	int weapon;
	int player_speed;
};
typedef struct _player_data PLAYER_DATA;

struct _plasma_data {
	int angle;
	int speed;
};
typedef struct _plasma_data PLASMA_DATA;

struct _killray_data {
	int angle;
	int speed;
	int dist;
};
typedef struct _killray_data KILLRAY_DATA;

struct _bomb_data {
	int angle;
	double speed;
};
typedef struct _bomb_data BOMB_DATA;


void player_init();
void player_move(SPRITE *s);
void player_keycontrol(SPRITE *s);
void player_colcheck(SPRITE *s, int mask);
void player_add_plasma(SPRITE *player);
void player_add_doubleplasma(SPRITE *player);
void player_add_quadplasma(SPRITE *player);
void player_add_killray(SPRITE *player);
void player_killray_move(SPRITE *s);
void player_plasma_move(SPRITE *s);
void player_bomb_add(SPRITE *s);
void player_bomb_move(SPRITE *s);
void weapon_colcheck(SPRITE *s, int angle, int remove);
#endif
